{-# LANGUAGE ForeignFunctionInterface #-}

module CUtil (tri, lockFile, unlockFile) where

import Foreign.C
import System.IO.Unsafe
import System.Posix.Types

foreign import ccall unsafe "c_tri" c_tri :: CDouble -> CDouble
foreign import ccall unsafe "lock_file" c_lockFile :: CInt -> IO ()
foreign import ccall unsafe "unlock_file" c_unlockFile :: CInt -> IO ()

{-# NOINLINE tri #-}
tri :: Double -> Double
tri = realToFrac . c_tri . realToFrac

lockFile :: Fd -> IO ()
lockFile = c_lockFile . fromIntegral

unlockFile :: Fd -> IO ()
unlockFile = c_unlockFile . fromIntegral
