module Camera (camera) where

import Algebra
import Color
import Geometry
import qualified LightProp as LP
import Maybe
import Monad
import Part
import Rand
import Types

camera :: (RandomGenD g) => Point -> Point -> Point -> Point -> Part g
camera eye gaze up right = Part trace
	where
		trace (Left Sink) =
			(	return $ Hit (error "distance fom source to camera undefined") eye ebdrf
			,	error "camera: distance from source/sink undefined"
			)
		trace _ = (MaybeT $ return Nothing, idvec)
		ebdrf (Left Sink) = dir
		ebdrf _ = zero_emit
		dir = RM 1 (either zvec f) r idvec (error "camera: ms_r undefined")
		f dir = if in_range then LP.C idvec (Just (x, y)) else zvec where
			u = gaze @. dir
			v = up @. dir / normSqr up
			w = right @. dir / normSqr right
			(y, x) = (v, w) ./ u
			in_range = u > 0 && x >= -1 && x < 1 && y >= -1 && y < 1
		r =
			do	v <- rand_norm_vec
				-- TODO: exclude directions v where (f v == zvec) from sampling
				return (f v, Right v)
