module LightProp (T(..)) where

import Algebra
import Color
import Monad
import Rand

data (RandomGenD g) => T g =
		C
			{	color :: !Color -- TODO: depend on dir
			,	pixel :: !(Maybe (Double, Double))
			}
	deriving Show

instance (RandomGenD g) => Vector (T g) where
	zvec = C zvec Nothing
	C a b .* c = C (a .* c) b
	C a Nothing @+ C a' Nothing = C (a @+ a') Nothing
	_ @+ _ = error "LightProp: @+ undefined for pixel /= Nothing"

mult_pixel :: Maybe (Double, Double) -> Maybe (Double, Double) -> Maybe (Double, Double)
mult_pixel Nothing p = p
mult_pixel p Nothing = p
mult_pixel _ _ = error "LightProp: @*: at least one pixel must be unspecified"

instance (RandomGenD g) => Algebra (T g) where
	C a b @* C a' b' = C (a @* a') (mult_pixel b b')

instance (RandomGenD g) => AlgebraU (T g) where
	idvec = C idvec Nothing
