module RList (RList, run_rlist) where

import Rand
import SList

data (RandomGenD g) => RList g =
		RLConsume !g !(SList Double)
	|	RLGen !g !(SList Double)

run_rlist :: (RandomGenD g) => Rand (RList g) a -> SList Double -> Rand g (a, SList Double)
run_rlist r l =
	R (\g -> case rfun r (RLConsume g l) of
		(x, RLConsume g' _) -> ((x, l), g')
		(x, RLGen g' extra) -> ((x, l `s_append` s_reverse extra), g'))

instance (RandomGenD g) => RandomGenD (RList g) where
	nextd (RLConsume g Empty) = nextd (RLGen g Empty)
	nextd (RLConsume g (Cons h t)) = (h, RLConsume g t)
	nextd (RLGen g l) = let (d, g') = nextd g in (d, RLGen g' (Cons d l))
	splitd = error "RList: splitd not supported"
