module SList (SList(..), s_length, s_map, s_append, s_reverse) where

data SList a = Empty | Cons !a !(SList a)

s_length :: (Num n) => SList a -> n
s_length = s_length' 0

s_length' :: (Num n) => n -> SList a -> n
s_length' n Empty = n
s_length' n (Cons _ t) = s_length' (1 + n) t

s_map :: (a -> b) -> SList a -> SList b
s_map _ Empty = Empty
s_map f (Cons h t) = Cons (f h) (s_map f t)

s_append :: SList a -> SList a -> SList a
s_append Empty y = y
s_append (Cons h t) y = Cons h (s_append t y)

s_reverse :: SList a -> SList a
s_reverse = s_reverse' Empty

s_reverse' :: SList a -> SList a -> SList a
s_reverse' rest Empty = rest
s_reverse' rest (Cons h t) = s_reverse' (Cons h rest) t
